﻿
//-----------------LayerSegment-----------------
//Segment of fields within a Layer

//param: fieldId is internal InDesign field id
EFI.LayerSegment = function(layer, selectableObject, startIndex, endIndex) {
	this.layer = layer;
	this.selectableObject = selectableObject;
	this.startIndex = startIndex;
	this.endIndex = endIndex;
	this.PDFFile = "";

	//alert("added segment for " + layer.layerIndex + " " + startIndex + " " + endIndex + " " + selectableObject);
};

EFI.LayerSegment.prototype.isStatic = function() {
	return this.selectableObject === undefined;
};

EFI.LayerSegment.prototype.getFileName = function() {
	return this.PDFFile;
};

EFI.LayerSegment.prototype.getSelectableObject = function() {
	return this.selectableObject;
};

EFI.LayerSegment.prototype.getObject = function() {
	var theObject = {};

	theObject.type = "image";
	theObject.id = EFI.Utils.getGUID(); //this.layer.getId() + "-" + this.startIndex; //need GUID added;
	theObject.x = 0;
	theObject.y = 0;
	theObject.width = EFI.Utils.getDocumentWidth();
	theObject.height = EFI.Utils.getDocumentHeight();
	theObject.fileName = this.PDFFile;
	theObject.layerId = this.layer.getId();

    return theObject;
};
//-----------------//Layer-----------------