﻿
//-----------------Layers-----------------
//Abstract object for InDesign Layers

//param: fieldId is internal InDesign field id
EFI.Layers = function() {
	this.baseLayers = EFI.UIHelper.getLayers();
	this.layers = this.getLayerObjects()
};

EFI.Layers.prototype.getLayers = function() {
	return this.layers;
};

EFI.Layers.prototype.getLayerObjects = function() {
	var aryLayers = [];

	for(var i=0; i < this.baseLayers.length; i++) {
		var layer = new EFI.Layer(this.baseLayers[i], i);

		aryLayers.push(layer);
	}

	return aryLayers;
};

//Export all static PDFs for this document
EFI.Layers.prototype.exportStaticPDFs = function(exportFolder, profile) {

	for(var i=0; i < this.layers.length; i++) {
		this.generateStaticLayerPDFs(i, exportFolder, profile);
	}
};

//Output static PDFs for this layer
EFI.Layers.prototype.generateStaticLayerPDFs = function(layerIndex, exportFolder, profile) {
	var fieldManager = EFI.ObjectFactory.getInstance("fieldManager");
	var outputLayer = this.layers[layerIndex];
	if(profile === undefined) profile = "[High Quality Print]";

	//hide all layers except one to output
	for(var i=0; i < this.layers.length; i++) {
		var layer = this.layers[i];
		if(layerIndex !== i) layer.hide();
	}

	outputLayer.generateStaticPDFs(exportFolder, profile);

	this.allLayersVisible();
};

EFI.Layers.prototype.allLayersVisible = function() {
	for(var i=0; i < this.layers.length; i++) {
		var layer = this.layers[i];

		layer.makeOriginalVisible();
	}
};
//-----------------//Layers-----------------