﻿
//-----------------SelectedObject-----------------
//The state of a field object and selection

EFI.SelectableObject = function (field, boxProperties) {
	this.isSelected = false;
	this.hasSingleSelection = false;
	this.isVariable = false;
	this.objectType = "";
	this.shape = undefined;

	if (field) this.setObject(field);

	if (boxProperties) {
		this.boxProperties = boxProperties;
	} else {
		this.boxProperties = new EFI.BoxProperties(this.getId());
	}

};

//arg: field
//is a native InDesign field, eg. TextFrame or ImageFrame
/*EFI.SelectableObject.prototype.setObject = function(field) {
	if (EFI.Utils.hasProperty(field, "id")) field = EFI.ObjectFactory.getInstance("fieldManager").getBaseObjectFromId(field.id);

	EFI.Utils.addDebugLog("EFI.SelectableObject.prototype.setObject - type: " + field.constructor.name);

	if(EFI.Utils.isTextObject(field)) {
		this.objectType = EFI.ConfigSettings.objectTypes.text;
		this.shape = new EFI.Text(field);
	} else {
		switch (field.constructor.name.toLowerCase()) {
			case EFI.ConfigSettings.objectTypes.textframe:
				this.objectType = EFI.ConfigSettings.objectTypes.textframe;
				this.shape = new EFI.TextField(field);
				break;
			case EFI.ConfigSettings.objectTypes.imageframe:
				this.objectType = EFI.ConfigSettings.objectTypes.imageframe;

				this.shape = new EFI.ImageField(field);
				break;
		}
	}

	EFI.Utils.addDebugLog("EFI.SelectableObject.prototype.setObject - id: " + this.getId());

	if(this.isTextFrame() || this.isImageFrame()) EFI.ObjectFactory.getInstance("fieldManager").addVariableObject(this);
};*/

//arg: field
//is a native InDesign field, eg. TextFrame or ImageFrame
EFI.SelectableObject.prototype.setObject = function(field) {
	//if sub image selected, we want the parent image frame
	if(field.constructor.name.toLowerCase() == EFI.ConfigSettings.objectTypes.image) field = field.parent;

	EFI.Utils.addDebugLog("EFI.SelectableObject.prototype.setObject - type: " + field.constructor.name);

	if(EFI.Utils.isTextObject(field)) {
		this.objectType = EFI.ConfigSettings.objectTypes.text;
		this.shape = new EFI.Text(field);
	} else {
		switch (field.constructor.name.toLowerCase()) {
			case EFI.ConfigSettings.objectTypes.textframe:
				this.objectType = EFI.ConfigSettings.objectTypes.textframe;
				this.shape = new EFI.TextField(field);
				break;
			case EFI.ConfigSettings.objectTypes.imageframe:
				this.objectType = EFI.ConfigSettings.objectTypes.imageframe;

				this.shape = new EFI.ImageField(field);
				break;
		}
	}

	EFI.Utils.addDebugLog("EFI.SelectableObject.prototype.setObject - id: " + this.getId());

	if(this.isTextFrame() || this.isImageFrame()) EFI.ObjectFactory.getInstance("fieldManager").addVariableObject(this);
};

EFI.SelectableObject.prototype.getId = function () {
	var id = undefined;

	if (this.hasShape()) id = this.shape.getId();

	return id;
};

//Get core InDesign object eg. TextFrame, Rectangle
EFI.SelectableObject.prototype.getBaseObject = function () {
	var baseObject = undefined;

	if (this.hasShape()) baseObject = this.getShape().getBaseObject();

	return baseObject;
};

EFI.SelectableObject.prototype.hasShape = function () {
	if (this.shape) {
		return true;
	} else {
		return false;
	}
};

EFI.SelectableObject.prototype.getShape = function () {
	return this.shape;
};

EFI.SelectableObject.prototype.getTextBlock = function () {
	var textBlock = undefined;

	if (this.isTextFrame() && this.hasShape()) textBlock = this.getShape().getTextBlock();
	return textBlock;
};

EFI.SelectableObject.prototype.isTextFrame = function () {
	return this.objectType === EFI.ConfigSettings.objectTypes.textframe;
};

EFI.SelectableObject.prototype.isImageFrame = function () {
	return this.objectType === EFI.ConfigSettings.objectTypes.imageframe;
};

EFI.SelectableObject.prototype.isText = function () {
	return this.objectType === EFI.ConfigSettings.objectTypes.text;
};

EFI.SelectableObject.prototype.getBoxProperties = function () {
	return this.boxProperties;
};

EFI.SelectableObject.prototype.getBoxSettingType = function () {
	if (this.boxProperties) {
		return this.boxProperties.getBoxType();
	} else {
		return "";
	}
};

EFI.SelectableObject.prototype.getBoxSettingVariable = function () {
	if (this.boxProperties) {
		return this.boxProperties.getBoxVariable();
	} else {
		return "";
	}
};

EFI.SelectableObject.prototype.getUserFieldByPlaceholder = function (placeholder) {
	var userFieldFound;

	if (this.isTextFrame()) {
		userFieldFound = this.getBoxProperties().getUserFieldByPlaceholder("placeholder");
	}

	return userFieldFound;
};

EFI.SelectableObject.prototype.setBoxProperties = function (theBoxProperties) {
	this.boxProperties = theBoxProperties;
};

EFI.SelectableObject.prototype.hide = function () {
	this.getShape().getBaseObject().visible = false;
};

EFI.SelectableObject.prototype.display = function () {
	this.getShape().getBaseObject().visible = true;
};

//-----------------//SelectableObject-----------------