﻿
//-----------------TextField-----------------
//The base structure for storing information about an InDesign TextFrame

EFI.TextField = function (textFrame) {
	EFI.Shape.call(this, textFrame);
	this.textBlock = new EFI.TextBlock(textFrame);
};

//Inherit from the Shape object
EFI.TextField.inheritsFrom(EFI.Shape);

//special for a Multi Field
EFI.TextField.prototype.getObjects = function () {
	var selectableObject = EFI.ObjectFactory.getInstance("fieldManager").getVariableObject(this.getId());
	var theObjects = [];

	var fields = this.textBlock.fields;

	for (var i = 0; i < fields.length; i++) {
		//contains Field location info
		var theObject = fields[i].getObject();

		//user selection options
		//var properties = this.getProperties(theObject.placeHolder);

		//this.assignProperties(theObject, properties);

		theObjects.push(theObject);
	}

	return theObjects;
};

EFI.TextField.prototype.addAdditionalObjectProperties = function (theObject) {
	theObject.defaultText = "lots of text YEA";

	return theObject;
};

EFI.TextField.prototype.getTextBlock = function () {
	return this.textBlock;
};
//-----------------//TextField-----------------