﻿
//-----------------TextBlockLine-----------------
//A single line of an InDesign TextFrame that has a variable place holder

EFI.TextBlockLine = function (textBlockLines, lineNumber) {
	this.fields = [];
	this.lines = textBlockLines;
	this.lineNumber = lineNumber;
	this.startCharacterPosition = 0;
};

EFI.TextBlockLine.prototype.getFirstField = function () {
	if (this.fields.length > 0) {
		return this.fields[0];
	} else {
		return undefined;
	}
};

EFI.TextBlockLine.prototype.getLastField = function () {
	if (this.fields.length > 0) {
		return this.fields[this.fields.length - 1];
	} else {
		return undefined;
	}
};

EFI.TextBlockLine.prototype.getStartCharacterPosition = function () {
	return this.startCharacterPosition;
};

EFI.TextBlockLine.prototype.getFieldPosition = function (position) {
	if (this.fields[position - 1]) {
		return this.fields[position - 1];
	} else {
		return undefined;
	}
};

EFI.TextBlockLine.prototype.getNextLine = function () {
	return this.lines.getNextLine(this.lineNumber);
};

EFI.TextBlockLine.prototype.getPreviousLine = function () {
	return this.lines.getPreviousLine(this.lineNumber);
};

EFI.TextBlockLine.prototype.setStartCharacterPosition = function (field) {
	if (field.getTextFrame()) this.startCharacterPosition = field.getTextFrame().lines[this.lineNumber - 1].index;
};

EFI.TextBlockLine.prototype.addField = function (field) {
	if (this.fields.length === 0) this.setStartCharacterPosition(field);
	this.fields.push(field);
};

//-----------------//TextBlockLine-----------------