﻿
//-----------------TextBlockLines-----------------
//Holds/Manages all the lines within an InDesign TextFrame

EFI.TextBlockLines = function () {
	this.textBlockLines = []; //array of TextBlockLine
};

EFI.TextBlockLines.prototype.addField = function (field, lineNumber, getStartPosition) {
	var line;

	if (this.containsLine(lineNumber)) {
		line = this.textBlockLines[lineNumber - 1];
	} else {
		line = new EFI.TextBlockLine(this, lineNumber);
		this.textBlockLines.push(line);
	}

	field.setTextBlockLine(line);

	line.addField(field, getStartPosition);
};

EFI.TextBlockLines.prototype.getLine = function (lineNumber) {
	var arrayNumber = lineNumber - 1;

	if (this.containsLine(lineNumber)) {
		return this.textBlockLines[arrayNumber];
	} else {
		return undefined;
	}
};

EFI.TextBlockLines.prototype.getNumberOfLines = function () {
	return this.textBlockLines.length;
};

EFI.TextBlockLines.prototype.getPreviousLine = function (lineNumber) {
	return this.getLine(lineNumber - 1);
};

EFI.TextBlockLines.prototype.getNextLine = function (lineNumber) {
	return this.getLine(lineNumber + 1);
};

EFI.TextBlockLines.prototype.containsLine = function (lineNumber) {
	var arrayNumber = lineNumber - 1;

	if (arrayNumber >= 0 && this.textBlockLines.length >= lineNumber) {
		return true;
	} else {
		return false;
	}
};

//-----------------//TextBlockLines-----------------