﻿
//----------------UserControlMapper-------------
//Handles the mapping between UI and Data Layer
EFI.UserControlMapper = {
	//param: action of type String
	//AddControls OR SaveControls
	//param: type of type String
	//Template OR FieldProperties
	doMapping: function(type, action) {
		var fieldManager = EFI.ObjectFactory.getInstance("fieldManager");
		var pluginUI = EFI.ObjectFactory.getInstance("pluginUI");
		var userControlModel;
		var uiObject;

		switch(type.toLowerCase()) {
			case "fieldproperties":
				userControlModel = fieldManager.getCurrentFieldProperties();
				uiObject = pluginUI.getMenuObject(EFI.ConfigSettings.menuObjectNames.properties);
				break;
			case "template":
				userControlModel = fieldManager.getCurrentTemplateProperties();
				uiObject = pluginUI.getMenuObject(EFI.ConfigSettings.menuObjectNames.template);
				break;
			case "boxproperties":
				userControlModel = fieldManager.getCurrentBoxProperties();
				uiObject = pluginUI.getMenuObject(EFI.ConfigSettings.menuObjectNames.fields);
				break;
		}

		if(action.toLowerCase() === "addcontrols") EFI.UIHelper.removeChildObjects(uiObject);

		if(userControlModel) {
			EFI.UserControlMapper.loopControls(userControlModel, action, uiObject, type.toLowerCase());
		}

		EFI.UIHelper.refreshLayout(uiObject);
	},

	loopControls: function(userControlModel, action, uiObject, menuType) {
		var fieldManager = EFI.ObjectFactory.getInstance("fieldManager");
		var aryProperties = EFI.Utils.getObjectOwnPropertiesNameOnly(userControlModel);

		for (var i = 0; i < aryProperties.length; i++) {
			if(aryProperties[i] !== "id") {
				var userProperty = userControlModel[aryProperties[i]];

				switch(action.toLowerCase()) {
					case "addcontrols":
						var field = EFI.UIHelper.addUserControl(uiObject, userProperty, menuType);
						break;
					case "savecontrols":
						var fieldValue = EFI.UIHelper.getUserControlValue(uiObject, userProperty);

						if (fieldValue !== undefined) {
							if(fieldValue === "Resource File Only") fieldManager.askAddAlphabet();
							fieldManager.setUserField(userControlModel, aryProperties[i], fieldValue);
						}

						break;
				}

			}
		}
	}
};
//----------------//UserControlMapper-----------