
//----------------TestHelper-------------
//Helps the Unit testing functions with commonly used functions

EFI.TestHelper = {
	textPlaceHolderRegEx: "\\[Firstname\\]",
	textPlaceHolderRegEx2: "\\[Center Field\\]",
	textPlaceHolderRegEx3: "\\[Vert Center\\]",
	textPlaceHolderRotatedRegEx3: "\\[Rotated 1\\]",
	textPlaceHolderMultilineRegEx4: "Multi line",
	textNoPlaceHolderRegEx: "Nothing variable",
	imageFrameObjectId: 444,
	imageObjectId: 439,

	selectText: function() {
		EFI.TestHelper.getTextObject().select();
	},

	getTextObjectSearch: function(regexText) {
		var item = undefined;
		var myDocument = EFI.UIHelper.getCurrentDocument();

		app.findGrepPreferences = NothingEnum.nothing;
		app.changeGrepPreferences = NothingEnum.nothing;

		app.findGrepPreferences.findWhat = regexText;
		var myFoundItems = myDocument.findGrep();

		if (myFoundItems.length === 1) {
			item = myFoundItems[0];
		} else {
			alert("Rule Engine: Couldn't find test text");
		}

		return item;
	},

	getTextObject: function(alternateRegEx) {
		var theRegEx;

		if(alternateRegEx) {
			theRegEx = alternateRegEx;
		} else {
			theRegEx = EFI.TestHelper.textPlaceHolderRegEx;
		}

		return EFI.TestHelper.getTextObjectSearch(theRegEx);
	},

	getTextFrameObject: function(alternateRegEx) {
		var textObject = EFI.TestHelper.getTextObject(alternateRegEx);
		var textFrame = textObject.parentTextFrames[0];

		return textFrame;
	},

	getTextFrameSelectedObject: function(alternateRegEx) {
		var selectedObject = EFI.ObjectFactory.getInstance("selectableObject", EFI.TestHelper.getTextFrameObject(alternateRegEx));

		selectedObject.hasSingleSelection = true;

		return selectedObject;
	},

	getImageFrameObject: function() {
		var item = EFI.UIHelper.getItemById(EFI.TestHelper.imageFrameObjectId);

		return item;
	},

	getImageObject: function() {
		var item = EFI.UIHelper.getItemById(EFI.TestHelper.imageObjectId);

		return item;
	},

	getImageFrameSelectedObject: function() {
		var selectedObject = EFI.ObjectFactory.getInstance("selectableObject", EFI.TestHelper.getImageFrameObject());

		selectedObject.hasSingleSelection = true;

		return selectedObject;
	},

	getImageObjectSelectedObject: function() {
		var selectedObject = EFI.ObjectFactory.getInstance("selectableObject", EFI.TestHelper.getImageObject());

		selectedObject.hasSingleSelection = true;

		return selectedObject;
	},

	fields: 0,
	resetFieldTest: function() {
		this.fields = 0;
	},

	getField: function()
	{
		var field = new EFI.Field();

		field.x = 10;
		field.y = 20;
		field.placeHolder = "testing" + this.fields;

		this.fields++;

		return field;
	}
};
//----------------//TestHelper-----------