﻿
//----------------TextFormatHelper-------------

EFI.TextFormatHelper = {
	getFontName: function(element) {
		/*var aryProperties = EFI.Utils.getObjectProperties(element.appliedFont);
		var strFontProperties = ""

		for(var i = 0; i < aryProperties.length; i++) {
			strFontProperties += aryProperties[i] + '\n';
		}

		EFI.Utils.addDebugLog(element.appliedFont.fullName + ": " + strFontProperties);*/
		return element.appliedFont.postscriptName;
	},

	getFontFile: function(element) {
        try {
            return element.appliedFont.location;
         } catch(error){
            return "";
         }
	},

	getColor: function(element) {
		var aryColors = element.style.fillColor.colorValue;
		var colorString = 'cmyk,' + aryColors[0] + ',' + aryColors[1] + ',' + aryColors[2] + ',' + aryColors[3];

		return colorString;
	},

	getLineHeight: function(element) {
		var lineHeight = element.leading;
		if(lineHeight === Leading.AUTO) lineHeight = 0;

		return lineHeight;
	},

	getFontSize: function(element) {
		return element.pointSize;
	},

	getFontStyle: function(element) {
		return element.fontStyle;
	},

	getAlignment: function(element) {
		var alignment = element.justification;

		switch (alignment) {
			case Justification.LEFT_ALIGN:
				alignment = "left";
				break;
			case Justification.CENTER_ALIGN:
				alignment = "center";
				break;
			case Justification.RIGHT_ALIGN:
				alignment = "right";
				break;
			case Justification.LEFT_JUSTIFIED:
				alignment = "left justified";
				break;
			case Justification.RIGHT_JUSTIFIED:
				alignment = "right justified";
				break;
			case Justification.CENTER_JUSTIFIED:
				alignment = "center justified";
				break;
			case Justification.FULLY_JUSTIFIED:
				alignment = "fully justified";
				break;
			case Justification.TO_BINDING_SIDE:
				alignment = "to binding side";
				break;
			case Justification.AWAY_FROM_BINDING_SIDE:
				alignment = "away from binding side";
				break;
			default:
				alignment = "left";
		}

		return alignment;
	},

	searchForFields: function(textObject) {
		if(textObject.contents !== "") {
			app.findGrepPreferences = NothingEnum.nothing;
			app.changeGrepPreferences = NothingEnum.nothing;
			app.findGrepPreferences.findWhat = EFI.ConfigSettings.globals.placeHolderRegEx;

			return textObject.findGrep();
		} else {
			return [];
		}
	},

	searchForMultline: function(textObject) {
		var blnAddedContents = false;
		var layerVisibility = textObject.itemLayer.visible;
		
		//if there is no content we can't read the font styles
		if(textObject.contents === "") {
			textObject.contents = " ";
			blnAddedContents = true;
		}

		if(textObject.contents !== "") {
			// we use findGrep only on visible layers
			textObject.itemLayer.visible = true;

			var checkEndCharacter = textObject.contents.indexOf(" ");
			var endCharacter = textObject.contents.length;

			if(checkEndCharacter > 0) endCharacter = checkEndCharacter;

			app.findGrepPreferences = NothingEnum.nothing;
			app.changeGrepPreferences = NothingEnum.nothing;
			app.findGrepPreferences.findWhat = EFI.Utils.escapeRegExp(textObject.contents.substring(0, endCharacter));

			var textObjects = textObject.findGrep();

			//if we added a space then remove it again
			if(blnAddedContents) textObject.contents = "";

			// now restore original layer visibility
			textObject.itemLayer.visible = layerVisibility;

			if(textObjects.length > 0) {
				return textObjects;
			} else {
				alert("No text found in Multiline box to get font properties");
				return [];
			}
		} else {
			alert("No text found in Multiline box to get font properties");
			return [];
		}
	},

	searchForText: function(textObject, text, startPos) {
		var textObjectFound = undefined;

		app.findGrepPreferences = NothingEnum.nothing;
		app.changeGrepPreferences = NothingEnum.nothing;
		app.findGrepPreferences.findWhat = EFI.Utils.escapeRegExp(text);

		var textObjects = textObject.findGrep();

		for(var i = 0; i < textObjects.length; i++) {
			if(textObjects[i].index === startPos) textObjectFound = textObjects[i];
		}

		return textObjectFound;
	},

	getBaseTextProperties: function() {
		var textDefaults = EFI.UIHelper.getCurrentDocument().textDefaults;
		var baseTextProperties = {};

		baseTextProperties.pointSize = EFI.TextFormatHelper.getFontSize(textDefaults);
		baseTextProperties.fontName = EFI.TextFormatHelper.getFontName(textDefaults);
         if(baseTextProperties.fontName){
            baseTextProperties.fontFile = EFI.TextFormatHelper.getFontFile(textDefaults);
         }
		return baseTextProperties;
	},

	getTextFrameOutput: function(textFrame) {
		app.taggedTextExportPreferences.characterSet = TagTextExportCharacterSet.ASCII;
		app.taggedTextExportPreferences.tagForm = TagTextForm.ABBREVIATED;

        try{
            var fileName = EFI.Utils.getTempFolder() + "/textFrameOutput.txt";
            var exportFile = new File(fileName);
            EFI.Utils.deleteFile(exportFile);

            textFrame.parentStory.exportFile(ExportFormat.TAGGED_TEXT, exportFile);
        } catch(err){            
            alert("Cannot write to " + fileName + ". " + err);
            throw(err);
        }
    
		return EFI.Utils.readTextFile(exportFile);
	}

};
//----------------//TextFormatHelper-----------