#targetengine "EFISmartCanvasAbout";

var releaseVersion = "1.0.1";
var releaseDate = "01 Feb 2017";
var box = new Window('dialog', "About");

try {

    function getCurrentFolder() {
        return new File((new File($.fileName)).parent.fullName);
	}

    function readVersionAndDateInfo() {
        // read version number and release date from revision.txt
        var file = File(getCurrentFolder() + "/revision.txt");
        
        file.open("r");
        var fileContent = file.read();
        var s = fileContent.split("|");
        
        if(s.length > 1){
            releaseVersion = s[0];
            releaseDate = s[1];
        }
    }

    function initDialog() {
        readVersionAndDateInfo();
        
        box.panel = box.add('panel', undefined, "EFI Smart Canvas Plugin");
        box.panel.group = box.panel.add('group', undefined, "");
        box.panel.group.orientation = 'column';

        box.panel.group.text1 = box.panel.group.add('statictext', undefined, " ");
        box.panel.group.text2 = box.panel.group.add('statictext', undefined, "Version: " + releaseVersion);
        box.panel.group.text3 = box.panel.group.add('statictext', undefined, "Released: " + releaseDate);
        box.panel.group.text4 = box.panel.group.add('statictext', undefined, "");

        box.panel.group.closeBtn = box.panel.group.add('button', undefined, "Close", { name: 'close' });

        box.panel.group.closeBtn.onClick = function () {
            box.close();
        };
    }
    
    initDialog();

    box.show();


} catch(error){
    alert(error);
}
